@echo off
rem
rem   D0ToHex.bat - CP/M 2.2 disk image (disk_image.dsk) to Intel-Hex converter-splitter
rem
rem   Intended to generate hex files to use with iDisk (S250317) Intel-Hex Disk image Loader for the Z80-MBC
rem
rem               Z80-MBC - HW ref: A041116
rem   Virtual Disk Module - HW ref. A110417
rem
rem   USAGE:      D1ToHex <disk_image.dsk>

if .%1==. goto :error2
set dskfile=%1
set dskfname=%~n1
if not exist %dskfile% goto :error1
srec_cat %dskfile% -binary -crop 0x0 0x8000 -o TEMP3.hex -intel
echo :00000109F6> %dskfname%_SEG0.hex
type TEMP3.hex >> %dskfname%_SEG0.hex
srec_cat %dskfile% -binary -crop 0x8000 0x10000 -o TEMP3.hex -intel
echo :00000109F6> %dskfname%_SEG1.hex
type TEMP3.hex >> %dskfname%_SEG1.hex
srec_cat %dskfile% -binary -crop 0x10000 0x18000 -o TEMP3.hex -intel
echo :00000109F6> %dskfname%_SEG2.hex
type TEMP3.hex >> %dskfname%_SEG2.hex
srec_cat %dskfile% -binary -crop 0x18000 0x20000 -o TEMP3.hex -intel
echo :00000109F6> %dskfname%_SEG3.hex
type TEMP3.hex >> %dskfname%_SEG3.hex

echo All done. Bye bye...
goto :end

:error2
echo Please specify a disk image file!
echo USAGE:      %0 ^<disk_image.dsk^>
goto :end

:error1
echo Error: file %dskfile% not found!

:end